/* --------------------------------------------------------- */
/*	BASIC-E													 */
/*	Copyright(C)2006 t.hara									 */
/* ========================================================= */
/*	BASIC-E body											 */
/* --------------------------------------------------------- */

#include "basic_e.h"
#include "zb_error.h"
#include <cstdio>

/* --------------------------------------------------------- */
void c_basic_e::initialize( c_basic_e_callback *p ) {

	resource.p_graphic_screen	= &graphic_screen;
	resource.p_text_screen		= &text_screen;
	resource.p_text_editor		= &text_editor;
	resource.p_interpreter		= &interpreter;
	resource.p_variable_manager	= &variable_manager;
	resource.p_keyboard			= &keyboard;
	resource.error_code			= c_zb_error::NO_PROBLEM;
	resource.p_callback			= p;

	interpreter.set_system_resource( &resource );
	text_editor.set_system_resource( &resource );
	keyboard.set_system_resource( &resource );

	/* create and initialize screen memories. */
	graphic_screen.create( width, height );
	text_screen.create( width, height, line_step );
	text_screen.set_graphic( &graphic_screen );

	text_editor.set_edit_mode( false );
	text_editor.put_str( "BASIC-E v0.0.5\xD\xA" );
	text_editor.put_str( "Copyright(C)2006 t.hara\xD\xA" );
	text_editor.put_str( "Ok\xD\xA" );
	text_editor.set_edit_mode( true );
}

/* --------------------------------------------------------- */
void c_basic_e::key( int key_code ) {

	keyboard.push_key( key_code );
}

/* --------------------------------------------------------- */
void c_basic_e::force_break( void ) {

	resource.error_code = c_zb_error::FORCE_BREAK;
}

/* --------------------------------------------------------- */
void c_basic_e::draw( unsigned short *p_vram ) {

	text_screen.draw( p_vram );
}

/* --------------------------------------------------------- */
void c_basic_e::update_draw( unsigned short *p_vram ) {

	text_screen.update( p_vram );
}

/* --------------------------------------------------------- */
void c_basic_e::run( const char * /* p_line */ ) {
	int key_code;

	resource.f_running = true;
	while( resource.f_running ) {
		key_code = keyboard.pop_key();
		if( key_code ) {
			text_editor.key( key_code );
		}
		else {
			resource.p_callback->sleep( 10 );
		}
	}
}
